--- src/backend/storage/buffer/bufmgr.c.orig	2014-08-18 14:10:36.937017089 -0400
+++ src/backend/storage/buffer/bufmgr.c	2014-08-19 16:56:13.515196557 -0400
@@ -29,7 +29,7 @@
  *		buf_table.c -- manages the buffer lookup table
  */
 #include "postgres.h"
-
+#include <sys/types.h> 
 #include <sys/file.h>
 #include <unistd.h>
 
@@ -50,7 +50,6 @@
 #include "utils/resowner_private.h"
 #include "utils/timestamp.h"
 
-
 /* Note: these two macros only work on shared buffers, not local ones! */
 #define BufHdrGetBlock(bufHdr)	((Block) (BufferBlocks + ((Size) (bufHdr)->buf_id) * BLCKSZ))
 #define BufferGetLSN(bufHdr)	(PageGetLSN(BufHdrGetBlock(bufHdr)))
@@ -63,6 +62,17 @@
 #define BUF_WRITTEN				0x01
 #define BUF_REUSABLE			0x02
 
+extern volatile struct BAiocbAnchor *BAiocbAnchr;  /*  anchor for all control blocks pertaining to aio  */
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+extern int numBufferAiocbs;        /*  total number of  BufferAiocbs in pool  */
+#if defined(USE_PREFETCH) && defined(USE_AIO_SIGEVENT)
+extern long num_startedaio;
+extern long num_cancelledaio;
+extern long num_signalledaio;                  /* count of number of signals delivered - counted by handlaiosignal */
+extern struct BAiocbIolock_chain_item volatile * volatile BAiocbIolock_anchor; /* anchor for chain of awaiting-release LWLock ptrs */
+#endif /* defined(USE_PREFETCH) && defined(USE_AIO_SIGEVENT)  */
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
 #define DROP_RELS_BSEARCH_THRESHOLD		20
 
 /* GUC variables */
@@ -78,26 +88,33 @@ bool		track_io_timing = false;
  */
 int			target_prefetch_pages = 0;
 
-/* local state for StartBufferIO and related functions */
+/* local state for StartBufferIO and related functions
+**  but ONLY for synchronous IO  -  not altered for aio
+*/
 static volatile BufferDesc *InProgressBuf = NULL;
 static bool IsForInput;
+pid_t this_backend_pid = 0;    /*    pid of this backend */
 
 /* local state for LockBufferForCleanup */
 static volatile BufferDesc *PinCountWaitBuf = NULL;
 
-
-static Buffer ReadBuffer_common(SMgrRelation reln, char relpersistence,
+extern int
+BufStartAsync(Relation reln, ForkNumber forkNum, BlockNumber blockNum , BufferAccessStrategy strategy);
+extern int
+BufCheckAsync(SMgrRelation caller_smgr, Relation caller_reln, volatile BufferDesc *buf_desc, int intention
+        ,BufferAccessStrategy strategy , int index_for_aio , bool spinLockHeld , LWLockId PartitionLock );
+Buffer ReadBuffer_common(SMgrRelation reln, char relpersistence,
 				  ForkNumber forkNum, BlockNumber blockNum,
 				  ReadBufferMode mode, BufferAccessStrategy strategy,
-				  bool *hit);
-static bool PinBuffer(volatile BufferDesc *buf, BufferAccessStrategy strategy);
-static void PinBuffer_Locked(volatile BufferDesc *buf);
-static void UnpinBuffer(volatile BufferDesc *buf, bool fixOwner);
+				  bool *hit , int index_for_aio);
+bool PinBuffer(volatile BufferDesc *buf, BufferAccessStrategy strategy);
+void PinBuffer_Locked(volatile BufferDesc *buf);
+void UnpinBuffer(volatile BufferDesc *buf, bool fixOwner);
 static void BufferSync(int flags);
 static int	SyncOneBuffer(int buf_id, bool skip_recently_used);
 static void WaitIO(volatile BufferDesc *buf);
-static bool StartBufferIO(volatile BufferDesc *buf, bool forInput);
-static void TerminateBufferIO(volatile BufferDesc *buf, bool clear_dirty,
+static bool StartBufferIO(volatile BufferDesc *buf, bool forInput , int index_for_aio );
+void TerminateBufferIO(volatile BufferDesc *buf, bool clear_dirty,
 				  int set_flag_bits);
 static void shared_buffer_write_error_callback(void *arg);
 static void local_buffer_write_error_callback(void *arg);
@@ -106,25 +123,67 @@ static volatile BufferDesc *BufferAlloc(
 			ForkNumber forkNum,
 			BlockNumber blockNum,
 			BufferAccessStrategy strategy,
-			bool *foundPtr);
+			int *foundPtr , int index_for_aio );
 static void FlushBuffer(volatile BufferDesc *buf, SMgrRelation reln);
 static void AtProcExit_Buffers(int code, Datum arg);
 static void CheckForBufferLeaks(void);
 static int	rnode_comparator(const void *p1, const void *p2);
 
+BlockNumber BlocknumOfBuffer(Buffer buffer);
+bool BlocknotinBuffer(Buffer buffer, Relation relation, BlockNumber blockNum);
 
 /*
  * PrefetchBuffer -- initiate asynchronous read of a block of a relation
  *
- * This is named by analogy to ReadBuffer but doesn't actually allocate a
- * buffer.  Instead it tries to ensure that a future ReadBuffer for the given
- * block will not be delayed by the I/O.  Prefetching is optional.
+ * This is named by analogy to ReadBuffer but allocates a buffer only if using asynchronous I/O.
+ * Its purpose  is to try to ensure that a future ReadBuffer for the given block
+ * will not be delayed by the I/O.  Prefetching is optional.
  * No-op if prefetching isn't compiled in.
- */
-void
-PrefetchBuffer(Relation reln, ForkNumber forkNum, BlockNumber blockNum)
-{
+ *
+ * Originally the prefetch simply called posix_fadvise() to recommend read-ahead into kernel page cache.
+ * Extended to provide an alternative of issuing an asynchronous aio_read() to read into a buffer.
+ * This extension has an implication on how this bufmgr component manages concurrent requests
+ * for the same disk block.
+ *
+ * Synchronous IO (read()) does not provide a means for waiting on another task's read if in progress,
+ * and bufmgr implements its own scheme in StartBufferIO, WaitIO, and TerminateBufferIO.
+ *
+ * Asynchronous IO (aio_read()) provides a means for waiting on this or another task's read if in progress,
+ * namely aio_suspend(),  which this extension uses.    Therefore,  although StartBufferIO and TerminateBufferIO
+ * are called as part of asynchronous prefetching,   their role is limited to maintaining the buffer desc flags,
+ * and they do not track the asynchronous IO itself.    Instead,   asynchronous IOs are tracked in 
+ * a separate set of shared control blocks,  the BufferAiocb list -
+ *   refer to     include/storage/buf_internals.h and storage/buffer/buf_init.c
+ *
+ * Another implication of asynchronous IO concerns buffer pinning.
+ * The buffer used for the prefetch is pinned before aio_read is issued.
+ * It is expected that the same task (and possibly others) will later ask to read the page
+ * and eventually release and unpin the buffer.
+ * However,  if the task which issued the aio_read later decides not to read the page,
+ * and return code indicates delta_pin_count > 0 (see below)
+ * it *must* instead issue a DiscardBuffer() (see function later in this file)
+ * so that its pin is released.
+ * Therefore,  each client which uses the PrefetchBuffer service must either always read all
+ * prefetched pages,  or keep track of prefetched pages and discard unread ones at end of scan.
+ *
+ * return code:   is an int bitmask defined in bufmgr.h
+        PREFTCHRC_BUF_PIN_INCREASED 0x01      pin count on buffer has been increased by 1
+        PREFTCHRC_BLK_ALREADY_PRESENT 0x02    block was already present in a buffer
+ *
+ * PREFTCHRC_BLK_ALREADY_PRESENT is a hint to caller that the prefetch may be unnecessary
+ */
+int
+PrefetchBuffer(Relation reln, ForkNumber forkNum, BlockNumber blockNum , BufferAccessStrategy strategy)
+{
+	Buffer		buf_id; /* indicates buffer containing the requested block  */
+        int             PrefetchBufferRc = 0; /*  return value as described above  */
+        int             PinCountOnEntry = 0;  /*  pin count on entry           */
+        int             PinCountdelta = 0;    /*  pin count delta increase     */
+
+
 #ifdef USE_PREFETCH
+
+	buf_id = -1;
 	Assert(RelationIsValid(reln));
 	Assert(BlockNumberIsValid(blockNum));
 
@@ -147,7 +206,12 @@ PrefetchBuffer(Relation reln, ForkNumber
 		BufferTag	newTag;		/* identity of requested block */
 		uint32		newHash;	/* hash value for newTag */
 		LWLock	   *newPartitionLock;	/* buffer partition lock for it */
-		int			buf_id;
+        int         BufStartAsyncrc = -1;  /*  retcode from BufStartAsync :
+                                                       **        0 if started successfully (which implies buffer was newly pinned )
+                                                       **       -1 if failed for some reason
+                                                       **        1+PrivateRefCount if we found desired buffer in buffer pool
+                                                       **  and we set it likewise if we find buffer in buffer pool
+                                                       */
 
 		/* create a tag so we can lookup the buffer */
 		INIT_BUFFERTAG(newTag, reln->rd_smgr->smgr_rnode.node,
@@ -159,28 +223,121 @@ PrefetchBuffer(Relation reln, ForkNumber
 
 		/* see if the block is in the buffer pool already */
 		LWLockAcquire(newPartitionLock, LW_SHARED);
-		buf_id = BufTableLookup(&newTag, newHash);
+		buf_id = (Buffer)BufTableLookup(&newTag, newHash);
+                if (buf_id >= 0) {
+                    PinCountOnEntry = PrivateRefCount[buf_id];  /*  pin count on entry               */
+                    BufStartAsyncrc = 1 + PinCountOnEntry; /* indicate this backends pin count - see above comment */
+                    PrefetchBufferRc = PREFTCHRC_BLK_ALREADY_PRESENT;       /* indicate buffer present */
+                } else {
+                    PrefetchBufferRc = 0;                                   /* indicate buffer not present */
+                }
 		LWLockRelease(newPartitionLock);
 
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+     not_in_buffers:
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
 		/* If not in buffers, initiate prefetch */
-		if (buf_id < 0)
+		if (buf_id < 0) {
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                    /*    try using async aio_read with a buffer */
+                    BufStartAsyncrc = BufStartAsync( reln, forkNum, blockNum , strategy );
+                    if (BufStartAsyncrc < 0) {
+                            pgBufferUsage.aio_read_noblok++;
+                    }
+#else /* not USE_AIO_ATOMIC_BUILTIN_COMP_SWAP so try the alternative that does not read the block into a postgresql buffer */
 			smgrprefetch(reln->rd_smgr, forkNum, blockNum);
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+		}
 
-		/*
-		 * If the block *is* in buffers, we do nothing.  This is not really
-		 * ideal: the block might be just about to be evicted, which would be
-		 * stupid since we know we are going to need it soon.  But the only
-		 * easy answer is to bump the usage_count, which does not seem like a
-		 * great solution: when the caller does ultimately touch the block,
-		 * usage_count would get bumped again, resulting in too much
-		 * favoritism for blocks that are involved in a prefetch sequence. A
-		 * real fix would involve some additional per-buffer state, and it's
-		 * not clear that there's enough of a problem to justify that.
+        if (  (buf_id >= 0) || (BufStartAsyncrc >= 1)  ) {
+                        /* The block *is* in buffers.    */
+#ifdef USE_AIO_ATOMIC_BUILTIN_COMP_SWAP
+                        pgBufferUsage.aio_read_noneed++;
+#ifndef USE_PREFETCH_BUT_DONT_PIN_ALREADY_PRESENT /* jury is out on whether the following wins but it ought to ...  */
+                        /*
+                        ** If this backend already had pinned it,
+                        ** or another backend had banked a pin on it,
+                        ** or there is an IO in progress,
+                        ** or it is not marked valid,
+                        ** then do nothing.
+                        ** Otherwise pin it and mark the buffer's pin as banked by this backend.
+                        ** Note  -  it may or not be pinned by another backend -
+                        **          it is ok for us to bank a pin on it
+                        **          *provided* the other backend did not bank its pin.
+                        **          The reason for this is that the banked-pin indicator is global -
+                        **          it can identify at most one process.
+                        */
+                        /* pgBufferUsage.aio_read_wasted++;  overload counter - only for debugging */
+                        if (BufStartAsyncrc == 1) {            /*   not pinned by me  */
+                              /*  pgBufferUsage.aio_read_wasted++;  overload counter - only for debugging */
+                              /*  note   -   all we can say with certainty is that the buffer is not pinned by me
+                              **             we cannot be sure that it is still in buffer pool
+                              **             so must go through the entire locking and searching all over again ...
 		 */
+                            LWLockAcquire(newPartitionLock, LW_SHARED);
+                            buf_id = (Buffer)BufTableLookup(&newTag, newHash);
+                            /* If in buffers, proceed */
+                            if (buf_id >= 0) {
+                                /*  since the block is now present,
+                                **  save the current pin count to ensure final delta is calculated correctly
+                                */
+                                PinCountOnEntry = PrivateRefCount[buf_id];  /*  pin count on entry               */
+                                if ( PinCountOnEntry == 0) { /*  paranoid check it's still not pinned by me */
+                                    volatile        BufferDesc *buf_desc;
+
+                                    buf_desc = &BufferDescriptors[buf_id];        /* found buffer descriptor */
+                                    LockBufHdr(buf_desc);
+                                    if (    (buf_desc->flags & BM_VALID)           /* buffer is valid        */
+                                         && (!(buf_desc->flags & (BM_IO_IN_PROGRESS|BM_AIO_IN_PROGRESS|BM_AIO_PREFETCH_PIN_BANKED))) /* buffer is not any of ... */
+                                       ) {
+                                        buf_desc->flags |= BM_AIO_PREFETCH_PIN_BANKED; /* bank the pin for next use by this task */
+                                        /*  note  - we can call PinBuffer_Locked with the BM_AIO_PREFETCH_PIN_BANKED flag set because it is not yet pinned by me */
+                                        buf_desc->freeNext = -(this_backend_pid);       /* remember which pid banked it */
+                                        /*  pgBufferUsage.aio_read_wasted--;      overload counter - not wasted after all - only for debugging */
+
+                                        /* Make sure we will have room to remember the buffer pin */
+                                        ResourceOwnerEnlargeBuffers(CurrentResourceOwner);
+
+                                        PinBuffer_Locked(buf_desc);
+	}
+                                    else {
+                                        UnlockBufHdr(buf_desc);
+                                    }
+                                }
+                            }
+                            LWLockRelease(newPartitionLock);
+                            /*  although unlikely,  maybe it was evicted while we were puttering about  */
+                            if (buf_id < 0) {
+                                pgBufferUsage.aio_read_noneed--;   /*   back out the accounting */
+                                goto not_in_buffers;               /*   and try again           */
 	}
-#endif   /* USE_PREFETCH */
 }
+#endif /*  USE_PREFETCH_BUT_DONT_PIN_ALREADY_PRESENT */
 
+#endif  /*  USE_AIO_ATOMIC_BUILTIN_COMP_SWAP */
+
+		}
+
+		if (buf_id >= 0) {
+			PinCountdelta = PrivateRefCount[buf_id] - PinCountOnEntry;  /*  pin count delta increase    */
+			if (  (PinCountdelta < 0) || (PinCountdelta > 1) ) {
+				  elog(ERROR,
+						 "PrefetchBuffer #%d : incremented pin count by %d on bufdesc %p refcount %u localpins %d\n"
+								  ,(buf_id+1) , PinCountdelta , &BufferDescriptors[buf_id] ,BufferDescriptors[buf_id].refcount , PrivateRefCount[buf_id]);
+}
+		} else
+		if (BufStartAsyncrc == 0) {  /* aio started successfully (which implies buffer was newly pinned ) */
+			PinCountdelta = 1;
+		}
+
+		/*  set final PrefetchBufferRc according to previous value */
+		PrefetchBufferRc |= PinCountdelta;  /* set the PREFTCHRC_BUF_PIN_INCREASED bit */
+	}
+
+#endif   /* USE_PREFETCH */
+
+	return PrefetchBufferRc; /*  return value as described above */
+}
 
 /*
  * ReadBuffer -- a shorthand for ReadBufferExtended, for reading from main
@@ -253,7 +410,7 @@ ReadBufferExtended(Relation reln, ForkNu
 	 */
 	pgstat_count_buffer_read(reln);
 	buf = ReadBuffer_common(reln->rd_smgr, reln->rd_rel->relpersistence,
-							forkNum, blockNum, mode, strategy, &hit);
+							forkNum, blockNum, mode, strategy, &hit , 0);
 	if (hit)
 		pgstat_count_buffer_hit(reln);
 	return buf;
@@ -281,7 +438,7 @@ ReadBufferWithoutRelcache(RelFileNode rn
 	Assert(InRecovery);
 
 	return ReadBuffer_common(smgr, RELPERSISTENCE_PERMANENT, forkNum, blockNum,
-							 mode, strategy, &hit);
+							 mode, strategy, &hit , 0);
 }
 
 
@@ -289,15 +446,18 @@ ReadBufferWithoutRelcache(RelFileNode rn
  * ReadBuffer_common -- common logic for all ReadBuffer variants
  *
  * *hit is set to true if the request was satisfied from shared buffer cache.
+ * index_for_aio ,  if -ve , is negative of ( index of the aiocb in the BufferAiocbs array + 3 )
+ *     which is passed through to StartBufferIO
  */
-static Buffer
+Buffer
 ReadBuffer_common(SMgrRelation smgr, char relpersistence, ForkNumber forkNum,
 				  BlockNumber blockNum, ReadBufferMode mode,
-				  BufferAccessStrategy strategy, bool *hit)
+				  BufferAccessStrategy strategy, bool *hit , int index_for_aio )
 {
 	volatile BufferDesc *bufHdr;
 	Block		bufBlock;
 	bool		found;
+        int             allocrc;             /*  retcode from BufferAlloc */
 	bool		isExtend;
 	bool		isLocalBuf = SmgrIsTemp(smgr);
 
@@ -329,16 +489,40 @@ ReadBuffer_common(SMgrRelation smgr, cha
 	}
 	else
 	{
+                allocrc = mode; /* pass mode to BufferAlloc since it must not wait for async io if RBM_NOREAD_FOR_PREFETCH */
 		/*
 		 * lookup the buffer.  IO_IN_PROGRESS is set if the requested block is
 		 * not currently in memory.
 		 */
 		bufHdr = BufferAlloc(smgr, relpersistence, forkNum, blockNum,
-							 strategy, &found);
-		if (found)
-			pgBufferUsage.shared_blks_hit++;
+							 strategy, &allocrc , index_for_aio );
+		if (allocrc < 0) {
+                    if (mode == RBM_ZERO_ON_ERROR || zero_damaged_pages)
+                    {
+                        ereport(WARNING,
+                                (errcode(ERRCODE_DATA_CORRUPTED),
+                                 errmsg("invalid page header in block %u of relation %s; zeroing out page",
+                                        blockNum,
+                                        relpath(smgr->smgr_rnode, forkNum))));
+                        bufBlock = BufHdrGetBlock(bufHdr);
+                        MemSet((char *) bufBlock, 0, BLCKSZ);
+                    }
 		else
+                      ereport(ERROR,
+                              (errcode(ERRCODE_DATA_CORRUPTED),
+                               errmsg("invalid page header in block %u of relation %s",
+                                      blockNum,
+                                      relpath(smgr->smgr_rnode, forkNum))));
+                        found = true;
+                }
+		else if (allocrc > 0) {
+			pgBufferUsage.shared_blks_hit++;
+                        found = true;
+                }
+		else {
 			pgBufferUsage.shared_blks_read++;
+                        found = false;
+                }
 	}
 
 	/* At this point we do NOT hold any locks. */
@@ -411,7 +595,7 @@ ReadBuffer_common(SMgrRelation smgr, cha
 				Assert(bufHdr->flags & BM_VALID);
 				bufHdr->flags &= ~BM_VALID;
 				UnlockBufHdr(bufHdr);
-			} while (!StartBufferIO(bufHdr, true));
+			} while (!StartBufferIO(bufHdr, true, 0));
 		}
 	}
 
@@ -431,6 +615,7 @@ ReadBuffer_common(SMgrRelation smgr, cha
 
 	bufBlock = isLocalBuf ? LocalBufHdrGetBlock(bufHdr) : BufHdrGetBlock(bufHdr);
 
+        if (mode != RBM_NOREAD_FOR_PREFETCH) {
 	if (isExtend)
 	{
 		/* new buffers are zero-filled */
@@ -500,6 +685,7 @@ ReadBuffer_common(SMgrRelation smgr, cha
 	VacuumPageMiss++;
 	if (VacuumCostActive)
 		VacuumCostBalance += VacuumCostPageMiss;
+	}
 
 	TRACE_POSTGRESQL_BUFFER_READ_DONE(forkNum, blockNum,
 									  smgr->smgr_rnode.node.spcNode,
@@ -521,21 +707,39 @@ ReadBuffer_common(SMgrRelation smgr, cha
  * the default strategy.  The selected buffer's usage_count is advanced when
  * using the default strategy, but otherwise possibly not (see PinBuffer).
  *
- * The returned buffer is pinned and is already marked as holding the
- * desired page.  If it already did have the desired page, *foundPtr is
- * set TRUE.  Otherwise, *foundPtr is set FALSE and the buffer is marked
+ * index_for_aio is an input parm which,  if non-zero,  identifies a BufferAiocb
+ * acquired by caller and to be used for any StartBufferIO performed by this routine.
+ * In this case,  if block not found in buffer pool and we allocate a new buffer,
+ * then we must maintain the spinlock on the buffer and pass it back to caller.
+ *
+ * foundPtr is input and output :
+ *  . input   -  indicates the read-buffer mode  ( see bufmgr.h )
+ *  . output  -  indicates the status of the buffer - see below
+ *
+ * Except for the case of RBM_NOREAD_FOR_PREFETCH and buffer is found,
+ * the returned buffer is pinned and is already marked as holding the
+ * desired page.
+ *  If it already did have the desired page and page content is valid,
+ *  *foundPtr is set to 1
+ *  If it already did have the desired page and mode is RBM_NOREAD_FOR_PREFETCH
+ *    and StartBufferIO returned false
+ *    (meaning it could not initialise the buffer for aio)
+ *  *foundPtr is set to 2
+ *  If it already did have the desired page but page content is invalid,
+ *  *foundPtr is set to -1
+ *   this can happen only if the buffer was read by an async read
+ *   and the aio is still in progress or pinned by the issuer of the startaio.
+ *  Otherwise, *foundPtr is set to 0 and the buffer is marked
  * as IO_IN_PROGRESS; ReadBuffer will now need to do I/O to fill it.
  *
- * *foundPtr is actually redundant with the buffer's BM_VALID flag, but
- * we keep it for simplicity in ReadBuffer.
- *
- * No locks are held either at entry or exit.
+ * No locks are held either at entry or exit EXCEPT for case noted above
+ * of passing an empty buffer back to async io caller ( index_for_aio set ).
  */
 static volatile BufferDesc *
 BufferAlloc(SMgrRelation smgr, char relpersistence, ForkNumber forkNum,
 			BlockNumber blockNum,
 			BufferAccessStrategy strategy,
-			bool *foundPtr)
+			int *foundPtr , int index_for_aio )
 {
 	BufferTag	newTag;			/* identity of requested block */
 	uint32		newHash;		/* hash value for newTag */
@@ -547,6 +751,13 @@ BufferAlloc(SMgrRelation smgr, char relp
 	int			buf_id;
 	volatile BufferDesc *buf;
 	bool		valid;
+        int             IntentionBufferrc;      /* retcode from BufCheckAsync */
+        bool            StartBufferIOrc;        /* retcode from StartBufferIO */
+        ReadBufferMode mode;
+
+
+        mode = *foundPtr;
+        *foundPtr = 0;
 
 	/* create a tag so we can lookup the buffer */
 	INIT_BUFFERTAG(newTag, smgr->smgr_rnode.node, forkNum, blockNum);
@@ -561,21 +772,53 @@ BufferAlloc(SMgrRelation smgr, char relp
 	if (buf_id >= 0)
 	{
 		/*
-		 * Found it.  Now, pin the buffer so no one can steal it from the
-		 * buffer pool, and check to see if the correct data has been loaded
-		 * into the buffer.
+		 * Found it.
 		 */
+                *foundPtr = 1;
 		buf = &BufferDescriptors[buf_id];
 
-		valid = PinBuffer(buf, strategy);
-
-		/* Can release the mapping lock as soon as we've pinned it */
+                /*   If prefetch mode,  then return immediately indicating found,
+                **   and NOTE in this case only,  we did not pin buffer.
+                **   In theory we might try to check whether the buffer is valid,  io in progress,  etc
+                **   but in practice it is simpler to abandon the prefetch if the buffer exists
+                */
+                if (mode == RBM_NOREAD_FOR_PREFETCH) {
+                    /* release the mapping lock and return    */
 		LWLockRelease(newPartitionLock);
+                } else {
+                    /*   note that the current request is for same tag as the one associated with the aio -
+                    **   so simply complete the aio and we have our buffer.
+                    **         If an aio was started on this buffer,
+                    **         check complete and wait for it if not.
+                    **         And,  if aio had been started,  then the task
+                    **         which issued the start aio already pinned it for this read,
+                    **         so if that task was me and the aio was successful,
+                    **         pass the current pin to this read without dropping and re-acquiring.
+                    **         this is all done by BufCheckAsync
+                    */
+                    IntentionBufferrc = BufCheckAsync(smgr , 0 , buf, BUF_INTENTION_WANT , strategy , index_for_aio , false , newPartitionLock );
 
-		*foundPtr = TRUE;
+                    /*       check to see if the correct data has been loaded into the buffer.  */
+                    valid = (IntentionBufferrc == BUF_INTENT_RC_VALID);
 
-		if (!valid)
-		{
+                    /*  check for serious IO errors   */
+                    if (!valid) {
+                        if (    (IntentionBufferrc != BUF_INTENT_RC_INVALID_NO_AIO)
+                             && (IntentionBufferrc != BUF_INTENT_RC_INVALID_AIO)
+                           ) {
+                            *foundPtr = -1;  /*  inform caller of serious error */
+                        }
+                        else
+                        if (IntentionBufferrc == BUF_INTENT_RC_INVALID_AIO) {
+                            goto proceed_with_not_found;  /*  yes,  I know,  a goto ... think of it as a break out of the if */
+                        }
+                     }
+
+                    /* BufCheckAsync pinned the buffer            */
+                    /* so can now release the mapping lock               */
+                    LWLockRelease(newPartitionLock);
+
+                    if (!valid) {
 			/*
 			 * We can only get here if (a) someone else is still reading in
 			 * the page, or (b) a previous read attempt failed.  We have to
@@ -583,19 +826,21 @@ BufferAlloc(SMgrRelation smgr, char relp
 			 * own read attempt if the page is still not BM_VALID.
 			 * StartBufferIO does it all.
 			 */
-			if (StartBufferIO(buf, true))
+                        if (StartBufferIO(buf, true, index_for_aio))
 			{
 				/*
 				 * If we get here, previous attempts to read the buffer must
 				 * have failed ... but we shall bravely try again.
 				 */
-				*foundPtr = FALSE;
+							*foundPtr = 0;
+						}
 			}
 		}
 
 		return buf;
 	}
 
+  proceed_with_not_found:
 	/*
 	 * Didn't find it in the buffer pool.  We'll have to initialize a new
 	 * buffer.  Remember to unlock the mapping lock while doing the work.
@@ -620,8 +865,10 @@ BufferAlloc(SMgrRelation smgr, char relp
 		/* Must copy buffer flags while we still hold the spinlock */
 		oldFlags = buf->flags;
 
-		/* Pin the buffer and then release the buffer spinlock */
-		PinBuffer_Locked(buf);
+        /*         If an aio was started on this buffer,
+        **         check complete and cancel it if not.
+        */
+        BufCheckAsync(smgr , 0 , buf, BUF_INTENTION_REJECT_OBTAIN_PIN , 0 , index_for_aio, true , 0 );
 
 		/* Now it's safe to release the freelist lock */
 		if (lock_held)
@@ -792,13 +1039,18 @@ BufferAlloc(SMgrRelation smgr, char relp
 				 * then set up our own read attempt if the page is still not
 				 * BM_VALID.  StartBufferIO does it all.
 				 */
-				if (StartBufferIO(buf, true))
+                                StartBufferIOrc = StartBufferIO(buf, true , index_for_aio); /* retcode from StartBufferIO */
+				if (StartBufferIOrc)
 				{
 					/*
 					 * If we get here, previous attempts to read the buffer
 					 * must have failed ... but we shall bravely try again.
 					 */
-					*foundPtr = FALSE;
+					*foundPtr = 0;
+                                } else
+                                if (mode == RBM_NOREAD_FOR_PREFETCH) {
+					UnpinBuffer(buf, true); /* must unpin if RBM_NOREAD_FOR_PREFETCH and found */
+                                        *foundPtr = 2;  /*  inform BufStartAsync that buffer must not be used */
 				}
 			}
 
@@ -861,10 +1113,17 @@ BufferAlloc(SMgrRelation smgr, char relp
 	 * lock.  If StartBufferIO returns false, then someone else managed to
 	 * read it before we did, so there's nothing left for BufferAlloc() to do.
 	 */
-	if (StartBufferIO(buf, true))
-		*foundPtr = FALSE;
-	else
-		*foundPtr = TRUE;
+        StartBufferIOrc = StartBufferIO(buf, true , index_for_aio); /* retcode from StartBufferIO */
+        if (StartBufferIOrc) {
+		*foundPtr = 0;
+        } else {
+                if (mode == RBM_NOREAD_FOR_PREFETCH) {
+                    UnpinBuffer(buf, true); /* must unpin if RBM_NOREAD_FOR_PREFETCH and found */
+                    *foundPtr = 2;  /*  inform BufStartAsync that buffer must not be used */
+                } else {
+                    *foundPtr = 1;
+                }
+        }
 
 	return buf;
 }
@@ -971,6 +1230,10 @@ retry:
 	/*
 	 * Insert the buffer at the head of the list of free buffers.
 	 */
+        /*   avoid confusing freelist with strange-looking freeNext */
+        if (buf->freeNext <= FREENEXT_BAIOCB_ORIGIN) { /* means was used for aiocb index */
+            buf->freeNext = FREENEXT_NOT_IN_LIST;
+        }
 	StrategyFreeBuffer(buf);
 }
 
@@ -1023,6 +1286,56 @@ MarkBufferDirty(Buffer buffer)
 	UnlockBufHdr(bufHdr);
 }
 
+/*  return the blocknum of the block in a buffer if it is valid
+**  if a shared buffer,  it must be pinned
+*/
+BlockNumber
+BlocknumOfBuffer(Buffer buffer)
+{
+	volatile BufferDesc *bufHdr;
+        BlockNumber rc = 0;
+
+	if (BufferIsValid(buffer)) {
+            if  (BufferIsLocal(buffer)) {
+                bufHdr = &LocalBufferDescriptors[-buffer - 1];
+            } else {
+                bufHdr = &BufferDescriptors[buffer - 1];
+            }
+
+            rc = bufHdr->tag.blockNum;
+        }
+
+        return rc;
+}
+
+/*  report whether specified buffer contains same or different block
+**  if a shared buffer,  it must be pinned
+*/
+bool
+BlocknotinBuffer(Buffer buffer,
+					 Relation relation,
+					 BlockNumber blockNum)
+{
+	volatile BufferDesc *bufHdr;
+        bool rc = false;
+
+	if (BufferIsValid(buffer)) {
+            if  (BufferIsLocal(buffer)) {
+                bufHdr = &LocalBufferDescriptors[-buffer - 1];
+            } else {
+                bufHdr = &BufferDescriptors[buffer - 1];
+            }
+
+            rc =
+                  (   (bufHdr->tag.blockNum != blockNum)
+                   || (!(RelFileNodeEquals(bufHdr->tag.rnode, relation->rd_node) ))
+                   || (bufHdr->tag.forkNum != MAIN_FORKNUM)
+                  );
+        }
+
+        return rc;
+}
+
 /*
  * ReleaseAndReadBuffer -- combine ReleaseBuffer() and ReadBuffer()
  *
